# FloorplanConfig

class `Floorplan.``FloorplanConfig`()

  ## Index

  Constructors

  - `constructor`

  Properties

  - `autoActivate`
  - `avatarColor`
  - `avatarOpacity`
  - `avatarOutlineColor`
  - `avatarScale`
  - `backgroundColor`
  - `backgroundOpacity`
  - `borderColor`
  - `borderOpacity`
  - `customAvatar`
  - `fixedAvatarScale`
  - `floorplanOrientation`
  - `overlayAnchor`
  - `overlayFeetPerPixel`
  - `overlayHeightUnit`
  - `overlayOffset`
  - `overlayOffsetXUnit`
  - `overlayOffsetYUnit`
  - `overlaySize`
  - `overlayWidthUnit`
  - `trackCameraEnabled`
  - `zoomLevel`

  Methods

  - `copy`

## Constructors

`Floorplan.FloorplanConfig.``constructor`()
  FloorplanConfig(): `FloorplanConfig`

  Returns: `FloorplanConfig`

## Properties

`Floorplan.FloorplanConfig.``autoActivate`
  autoActivate: `FloorplanAutoActivation`

  Determines the conditions under which the floorplan will be auto-activated. (default: [[FloorplanAutoActivation.BimWalk]])

`Floorplan.FloorplanConfig.``avatarColor`
  avatarColor: `Color`

  Determines the primary color of the avatar shown in the overlay. (default: `Color(255,0,255)`)

`Floorplan.FloorplanConfig.``avatarOpacity`
  avatarOpacity: number

  Determines the opacity of the avatar. Valid values must be in the range `[0, 1]`. (default: `1.0`)

`Floorplan.FloorplanConfig.``avatarOutlineColor`
  avatarOutlineColor: `Color`

  Determines the outline color of the avatar shown in the overlay. (default: `black`)

`Floorplan.FloorplanConfig.``avatarScale`
  avatarScale: number

  Determines the scale-factor of the avatar. Valid values must be in the range `[0.1, 10]`. (default: `1.0`)

`Floorplan.FloorplanConfig.``backgroundColor`
  backgroundColor: `Color`

  Determines the background color of the overlay window. (default: `white`)

`Floorplan.FloorplanConfig.``backgroundOpacity`
  backgroundOpacity: number

  Determines the opacity of the overlay background. Valid values must be in the range `[0, 1]`. (default: `0.25`)

`Floorplan.FloorplanConfig.``borderColor`
  borderColor: `Color`

  Determines the color of the overlay window border. (default: `black`)

`Floorplan.FloorplanConfig.``borderOpacity`
  borderOpacity: number

  Determines the opacity of the overlay window border. Valid values must be in the range `[0, 1]`. (default: `1.0`)

`Floorplan.FloorplanConfig.``customAvatar`
  customAvatar: (None | number)

  Setting this to a valid [[NodeId]] will allow for a custom avatar. To use a custom avatar, consider the following:

  - The overlay always draws in orthographic mode with the camera pointing down the Z axis from + to -. The avatar geometry is therefore assumed to be defined in the X/Y plane, with forward pointing in the positive Y direction.
  - The avatar is scaled under the assumption that its units are in feet and the actual camera-eye will correspond to `0,0,0` within the avatar geometry.
  - The [[FloorplanManager]] will take ownership of the custom node. The caller should not try to delete it, ever.
  - The custom node will survive across model changes.
  - The custom node will survive across any calls to [[deactivate]].
  - Any previous custom avatar node will be deleted when a new custom avatar is set.
  - Setting this to `null` will restore the default avatar.
  - The avatar background and outline colors/opacities will not be applied to a custom avatar. The user must set these manually as needed for any custom avatar. The custom avatar [[NodeId]] will not change and can thus be maintained by the user for setting node properties as needed.

  (default: `null`)

`Floorplan.FloorplanConfig.``fixedAvatarScale`
  fixedAvatarScale: boolean

  When this is `false`, the avatar size will scale with the floorplan size. For large floorplans, the avatar may appear small. When this is `true`, the avatar will be the same size for all floorplans. (default: `true`)

`Floorplan.FloorplanConfig.``floorplanOrientation`
  floorplanOrientation: `FloorplanOrientation`

  Determines the drawing orientation of floorplan and avatar. (default: [[FloorplanOrientation.NorthUp]])

`Floorplan.FloorplanConfig.``overlayAnchor`
  overlayAnchor: `OverlayAnchor`

  The [[OverlayAnchor]] for the floorplan overlay window. See [[OverlayManager.setViewport]]. (default: [[OverlayAnchor.LowerRightCorner]])

`Floorplan.FloorplanConfig.``overlayFeetPerPixel`
  overlayFeetPerPixel: number

  Determines the scale of the floorplan within the overlay window in terms of feet-per-pixel. This value is combined with [[zoomLevel]] to determine the overall display scaling. The intent is for this value to stay fixed after being set initially, while [[zoomLevel]] is used to easily change the zoom-level of the overlay

`Floorplan.FloorplanConfig.``overlayHeightUnit`
  overlayHeightUnit: `OverlayUnit`

  The [[OverlayUnit]] type for the [[overlaySize]] height. (default: [[OverlayUnit.ProportionOfOtherDimension]])

`Floorplan.FloorplanConfig.``overlayOffset`
  overlayOffset: `Point2`

  The X/Y values used with [[OverlayManager.setViewport]]. (default: `0, 0`)

`Floorplan.FloorplanConfig.``overlayOffsetXUnit`
  overlayOffsetXUnit: `OverlayUnit`

  The [[OverlayUnit]] type for the [[overlayOffset]] x coordinate. (default: [[OverlayUnit.Pixels]])

`Floorplan.FloorplanConfig.``overlayOffsetYUnit`
  overlayOffsetYUnit: `OverlayUnit`

  The [[OverlayUnit]] type for the [[overlayOffset]] y coordinate. (default: [[OverlayUnit.Pixels]])

`Floorplan.FloorplanConfig.``overlaySize`
  overlaySize: `Point2`

  Determines the size of the overlay. See [[OverlayManager.setViewport]] for an understanding of how the size and [[OverlayUnit]] values are used. (default: `0.25, 1.0`)

`Floorplan.FloorplanConfig.``overlayWidthUnit`
  overlayWidthUnit: `OverlayUnit`

  The [[OverlayUnit]] type for the [[overlaySize]] width. (default: [[OverlayUnit.ProportionOfCanvas]])

`Floorplan.FloorplanConfig.``trackCameraEnabled`
  trackCameraEnabled: boolean

  Setting this to `true` will move the floorplan with the camera to keep the avatar centered. When this is `false`, the floorplan will stay fixed in place, and the avatar will move.

`Floorplan.FloorplanConfig.``zoomLevel`
  zoomLevel: number

  Sets the zoom level for the floorplan display. A value of 1.0 is the standard view. Values greater will zoom-in, while smaller values will zoom-out. Valid values must be in the range `[0.1, 10]`. (default: `1.0`)

## Methods

`Floorplan.FloorplanConfig.``copy`()
  copy(): `FloorplanConfig`

  Per-floor information.

  Returns: `FloorplanConfig`

  > Copy of this configuration object.

Conversation saved
HOOPSY BETA

### Hello! I'm HOOPSY

Your Docs generative AI assistant. Ask me anything about HOOPS Visualize Web or choose a sample question below to start a conversation:

What is HOOPS Visualize Web?
What are the latest release notes for HOOPS Visualize Web?
How do I start evaluating HOOPS Visualize Web?
How do I write my first sample application?
How can I get assistance?

HOOPSY may store conversations according to OpenAI's policy. Responses may not always be accurate.

HOOPSY is thinking...